<!-- TITLE -->
<app-header
    title="Consultation"
    subTitle="Détails de votre rendez-vous"
    [border]="false"
></app-header>
<ion-content class="border-top-1 border-0 border-solid has-border-gray">
    <app-notification
        *ngIf="consultationInfo"
        [message]="consultationInfo"
        icon="warning"
        iconColor="warning"
        data-test-id="app-notification"
        class="block has-background-blue-pale ion-margin px-6"
    >
    </app-notification>

    <app-diary
        #diaryComponent
        [diary]="diary"
        [showPersonalInfo]="true"
        class="block mx-16 mt-10"
    ></app-diary>
    <!-- diagnostic -->
    <div
        class="ion-margin"
        *ngIf="diary.status === ConsultationStatus.terminated || isOpen; else symptom"
    >
        <!-- Symptoms -->
        <app-card class="mt-25 mx-16" [hasShadow]="false">
            <div
                content
                class="consultation has-background-pale-grey-light radius-17"
            >
                <ion-row class="ion-nowrap">
                    <!-- Consultation -->
                    <ion-col size="auto" class="ion-no-padding">
                        <div
                            class="flex consultation__icon width-66 has-background-white radius-9 ion-text-center border-solid border-1 has-border-pale-grey-light ion-justify-content-center ion-align-items-center"
                        >
                            <ion-icon
                                name="alert-circle"
                                class="size-52"
                                color="warning"
                            ></ion-icon>
                        </div>
                    </ion-col>

                    <ion-col class="flex ion-align-items-center pl-10">
                        <ion-text
                            class="size-11 weight-400 ion-text-left mt-3"
                            color="black"
                        >
                            {{ diary.problemDescription }}
                        </ion-text>
                    </ion-col>
                </ion-row>
            </div>
        </app-card>
        <!-- Diagnostic -->
        <app-card *ngIf="diary.diagnostique" class="mt-25" [hasShadow]="false">
            <div
                content
                class="consultation has-background-pale-grey-light radius-17"
            >
                <ion-row class="ion-nowrap">
                    <!-- Consultation -->
                    <ion-col size="auto" class="ion-no-padding">
                        <div
                            class="flex consultation__icon width-66 has-background-white radius-9 ion-text-center border-solid border-1 has-border-pale-grey-light ion-justify-content-center ion-align-items-center"
                        >
                            <ion-icon
                                name="checkmark-circle"
                                class="size-52"
                                color="primary-fade"
                            ></ion-icon>
                        </div>
                    </ion-col>

                    <ion-col class="flex ion-align-items-center pl-10">
                        <ion-text
                            class="size-11 weight-400 ion-text-left mt-3"
                            color="black"
                        >
                            {{ diary.diagnostique }}
                        </ion-text>
                    </ion-col>
                </ion-row>
            </div>
        </app-card>
    </div>
    <!-- Symptom -->
    <ng-template #symptom>
        <ion-row class="ion-align-content-center ion-no-padding mx-15">
            <ion-col class="ion-no-padding">
                <ion-row class="ion-align-items-center ion-no-padding pt-25">
                    <ion-col size="auto" class="ion-no-padding pt-4">
                        <ion-icon
                            name="alert-circle"
                            color="warning"
                            class="size-24"
                        ></ion-icon>
                    </ion-col>
                    <ion-col class="size-10">
                        <ion-text
                            class="size-14 has-text-secondary"
                            color="dove-dark"
                        >
                            Symptômes
                        </ion-text>
                    </ion-col>
                </ion-row>
                <p
                    class="has-text-primary size-11 weight-400 is-black-thin mx-8 mb-20"
                >
                    {{diary.problemDescription}}
                </p>
            </ion-col>
        </ion-row>
    </ng-template>
    <ion-row
        class="ion-align-items-center ion-no-padding mx-15"
        *ngIf="diary.images.length > 0"
        data-test-id="file-header"
    >
        <ion-col size="auto" class="ion-no-padding">
            <ion-icon
                size="large"
                name="image"
                class="mr-1 mt-3"
                color="lime-green"
            ></ion-icon>
        </ion-col>
        <ion-col class="size-10">
            <ion-text
                class="size-14 has-text-secondary mt-10"
                color="dove-dark"
            >
                Fichiers
            </ion-text>
        </ion-col>
    </ion-row>
    <!-- doawnload payment proof  -->

    <app-img-list [data]="listMedia" class="block ml-8"> </app-img-list>

    <div class="mx-24">
        <a
            *ngIf="diary.transaction"
            [href]="diary.transaction.paymentProof"
            download
            class="consultation__text--underline is-blue-light size-11 weight-400 has-text-primary mb-4"
        >
            Téléchargez la preuve de paiement
        </a>
    </div>

    <div *ngIf="diary.ordonnance; else noPrescription" class="mt-14 mx-24">
        <!-- load order when consultation status is finish -->
        <a
            [href]="diary.ordonnance.lien"
            download
            data-testid="download-prescription"
            class="consultation__text--underline is-blue-light size-11 weight-400 has-text-primary mb-4"
        >
            Téléchargez l'ordonnance
        </a>
    </div>
    <ng-template #noPrescription>
        <div class="mt-20 ml-29 mr-23">
            <form
                class="ion-no-padding ion-margin-vertical"
                [formGroup]="consultationForm"
                *ngIf="diary.status === ConsultationStatus.terminated"
            >
                <div
                    class="flex size-14 pl-7 border-solid border-1 has-border-primary-light ion-align-items-center ion-justify-content-between has-background-grey-thin is-grey-lighter height-45"
                    (click)="file.click()"
                    (keyPress)="file.click()"
                    data-testid="add-file"
                >
                    Chargez une ordonnance
                    <span
                        class="consultation__file__container ion-align-items-center ion-justify-content-center has-background-primary height-45 width-58"
                    >
                        <ion-icon
                            name="download-outline"
                            color="white"
                            size="large"
                            class="consultation__file__container__icon"
                        ></ion-icon>
                    </span>

                    <input
                        #file
                        formControlName="file"
                        type="file"
                        hidden
                        [accept]="acceptedFileTypes"
                        (change)="loadPrescription($event)"
                    />
                </div>
            </form>
        </div>
    </ng-template>

    <!-- close consultation -->
    <ion-row
        class="ion-justify-content-center ion-align-items-center ion-margin-top"
        *ngIf="diary.status === ConsultationStatus.waitingDiagnostic"
    >
        <ion-col class="ion-padding size-17" size="auto">
            <ion-modal
                #closemodal
                [initialBreakpoint]="1"
                [breakpoints]="[0,1]"
                class="consultation__close-modal"
                [isOpen]="isOpen"
                (ionModalWillDismiss)="openCloseModal(false)"
                [showBackdrop]="false"
            >
                <ng-template>
                    <ion-header class="has-background-white">
                        <ion-toolbar
                            color="white"
                            class="pl-10 radius-tl-50 radius-tr-50"
                            [ngClass]="{'is-primary': !submitError, 'is-danger': diagnostic && submitError}"
                        >
                            <ion-title
                                class="ion-no-padding size-17 ion-text-left has-text-secondary weight-bold"
                                >{{ modalTitle }}</ion-title
                            >
                        </ion-toolbar>
                    </ion-header>
                    <div class="height-160">
                        <app-input-text
                            [control]="submitForm"
                            name="description"
                            inputType="textarea"
                            [rows]="4"
                            [errorMessages]="[errors.required, errors.lettersOnly]"
                            [validators]="[requiredValidator]"
                            [hasBorder]="false"
                            class="size-11"
                        >
                        </app-input-text>
                    </div>

                    <ion-row
                        class="ion-justify-content-center ion-align-items-center"
                    >
                        <ion-col size="10" class="pb-15">
                            <app-button
                                [title]="buttonTitle"
                                [disabled]="!submitForm.valid"
                                [loading]="loading"
                                shape="round"
                                expand="full"
                                fill="solid"
                                (click)="close()"
                                (keyPress)="close()"
                                class="ion-no-padding size-17 is-white has-text-secondary"
                                id="open-modal"
                            >
                            </app-button>
                        </ion-col>
                    </ion-row>
                </ng-template>
            </ion-modal>
        </ion-col>
    </ion-row>
</ion-content>
<ion-footer *ngIf="showFooter" class="ion-no-border ion-padding-top">
    <ion-row class="ion-justify-content-center ion-align-items-center">
        <ion-col class="is-white" size="10">
            <div class="mb-12">
                <!-- Conrfim consultation  -->
                <app-button
                    data-test-id="confirmButton"
                    *ngIf="diary.status
                        === ConsultationStatus.waiting && diary.id"
                    [title]="'Confirmer le rendez-vous'"
                    [loading]="loading"
                    (click)="confirm()"
                    (keyPress)="confirm()"
                    shape="round"
                    expand="full"
                    class="ion-no-padding ion-no-margin mb-12"
                >
                </app-button>
                <!-- Cancel or tranfer consultation -->
                <app-button
                    *ngIf="isCancellable && diary.id && diary.status !== ConsultationStatus.confirmByDoctor"
                    data-test-id="cancelButton"
                    [title]="'Annuler ou transférer'"
                    routerLink="transfert"
                    [queryParams]="{diaryId: diary.id}"
                    shape="round"
                    expand="full"
                    fill="clear"
                    class="block border-solid border-1 has-border-primary radius-40 ion-no-padding is-black"
                >
                </app-button>
                <!-- finish consultation button -->
                <app-button
                    *ngIf="diary.status === ConsultationStatus.waitingDiagnostic"
                    title="Terminer la consultation"
                    shape="round"
                    expand="full"
                    fill="solid"
                    class="ion-no-padding weight-400 has-text-secondary size-17"
                    (click)="openCloseModal(true)"
                    (keyPress)="openCloseModal(true)"
                >
                </app-button>
                <!-- Submit case  -->
                <app-button
                    *ngIf="diary.status === ConsultationStatus.terminated && !diary.idCase"
                    title="Soumettre un cas clinique"
                    [loading]="loading"
                    (click)="submitCase()"
                    (keyPress)="submitCase()"
                    shape="round"
                    expand="full"
                    fill="solid"
                    class="ion-no-padding ion-no-margin"
                >
                </app-button>
                <!-- Start consultation  -->
                <app-button
                    data-test-id="startConsultationButton"
                    *ngIf="diary.status === ConsultationStatus.payed"
                    title="Démarrer la téléconsultation"
                    [disabled]="!diaryComponent.showVideo"
                    (onClick)="goToMeeting()"
                    shape="round"
                    expand="full"
                    fill="solid"
                    class="ion-no-padding ion-no-margin"
                >
                </app-button>
            </div>
        </ion-col>
    </ion-row>
</ion-footer>
